﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataGridBug
{
    using System.Collections.ObjectModel;

    using Infragistics.Windows.DataPresenter;

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private MainViewModel vm;

        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = this.vm = new MainViewModel();
        }

        private void DRP_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            DataRecordPresenter drp = (DataRecordPresenter)sender;
            XamDataGrid grid = SourceData;
            if (drp != null)
            {
                DataObject data = new DataObject(drp);
                if (data != null)
                {
                    DragDrop.DoDragDrop(grid, data, DragDropEffects.Copy);
                }
            }

        } 

        private void XamDataGrid_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            return;
            XamDataGrid grid = (XamDataGrid)sender;
            
            DataRecordPresenter dr = new DataRecordPresenter();
                                          
            DataItemPresenter dataItem = this.GetDataItemPresenterFromHitTest(grid, e.GetPosition(grid)) as DataItemPresenter;

           

            // Get the active record
            if (dataItem != null)
            {
                if (dataItem.Record != null)
                {
                    dr = DataRecordPresenter.FromRecord(dataItem.Record) as DataRecordPresenter;
                }
            }
            else
            {
                dr = null;
            }

            if (dr != null)
            {
                DataObject data = new DataObject(dr);

                // Perform drag and drop
                if (data != null)
                {
                    DragDrop.DoDragDrop(grid, data, DragDropEffects.Copy);
                }
            }
        }

        private UIElement GetDataItemPresenterFromHitTest(UIElement dragSourceContainer, Point pt)
        {
            HitTestResult hr = VisualTreeHelper.HitTest(dragSourceContainer, pt);

            UIElement element = hr.VisualHit as UIElement;

            while (element != null && !(element is DataItemPresenter))
            {
                element = VisualTreeHelper.GetParent(element) as UIElement;
            }

            return element;
        }

        private void XamDataGrid_Drop(object sender, DragEventArgs e)
        {
            XamDataGrid parent = (XamDataGrid)sender;
            object data;

            if ((data = e.Data.GetData(typeof(DataRecordPresenter)) as DataRecordPresenter) != null)
            {
                DataRecord draggedRecord = (data as DataRecordPresenter).Record as DataRecord;

                if (draggedRecord != null)
                {
                    if (draggedRecord.DataItem is Person)
                    {
                        this.vm.AddData(draggedRecord.DataItem as Person);
                    }
                }
            }
        }
    }
}
